package com.alibaba.cloud.security.sample.service;

import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.profile.DefaultProfile;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

@Service
public class IDaaSClientService {
    // 阿里云账号AccessKey拥有所有API的访问权限，风险很高。强烈建议您创建并使用RAM用户进行API访问或日常运维，请登录RAM控制台创建RAM用户。
    // 可以把AccessKey 和 AccessKeySecret 保存在环境变量。
    // String accessKeyId = System.getenv("ACCESS_KEY_ID");
    // String accessKeySecret = System.getenv("ACCESS_KEY_SECRET");
    // 您也可以根据业务需要，保存到配置文件里。
    // 强烈建议不要把 AccessKey 和 AccessKeySecret 保存到代码里，会存在密钥泄漏风险
    @Value("${app.idaas.accessKeyId}")
    String alibabaCloudIdaasAccessKeyId;
    @Value("${app.idaas.accessKeySecret}")
    String alibabaCloudIdaasAccessKeySecret;
    @Value("${app.idaas.regionId}")
    String alibabaCloudIdaasRegionId;

    public IAcsClient getClient() {
        DefaultProfile profile = DefaultProfile.getProfile(
                alibabaCloudIdaasRegionId,
                alibabaCloudIdaasAccessKeyId,
                alibabaCloudIdaasAccessKeySecret);
        // addEndpoint only for inner test
        DefaultProfile.addEndpoint("cn-hangzhou-daily",
                "idaas-doraemon",
                "idaas-doraemon-daily.aliyuncs.com");

        return new DefaultAcsClient(profile);
    }
}
