package com.alibaba.cloud.security.sample.util;

import com.alibaba.cloud.security.sample.constants.Constants;

import javax.servlet.http.HttpSession;

/**
 * 大型项目通常不使用Servlet容器内提供的默认Session服务，使用Redis/Memcached等支持分布式KV存储的服务替代，本实现仅为Mock实现
 */
public class LoginUtil {

    public static void login(HttpSession session, String userId) {
        session.setAttribute(Constants.SESSION_USER_KEY, userId);
    }

    public static void logout(HttpSession session) {
        session.removeAttribute(Constants.SESSION_USER_KEY);
    }

    public static String getLoginUserId(HttpSession session) {
        return (String) session.getAttribute(Constants.SESSION_USER_KEY);
    }
}
