async function doSignUp() {
    let loginId = $('#loginId').val();
    let signUpResponse = await doFetch('/user/create', {
        loginId: loginId,
        displayName: $('#displayName').val(),
        password: $('#password').val()
    });
    console.log(signUpResponse);
    if (signUpResponse.status === 200 && window.localStorage) {
        window.localStorage['loginId'] = loginId;
    }
    return signUpResponse;
}

async function checkPassword() {
    let password = document.getElementById('password').value;
    if (password === '') {
        globalContext.passwordMessage = {show: false, ok: false, message: ''};
        return;
    }
    if (password.length < 4) {
        globalContext.passwordMessage = {show: true, ok: false, message: 'Password is too short.'};
        return;
    }
    let passwordSha1 = sha1(password);
    let passwordSha1Prefix = passwordSha1.substring(0, 6);
    // globalContext.passwordMessage = {show: true, ok: false, message: passwordSha1Prefix};
    let checkResponse = await doFetch('/password/check', {
        passwordSha1Prefix: passwordSha1Prefix
    });
    if (checkResponse.status === 200 && password === document.getElementById('password').value) {
        let checkResponseJson = await checkResponse.json();
        console.log(passwordSha1Prefix, passwordSha1);
        console.log(checkResponseJson);
        console.log(JSON.stringify(checkResponseJson.passwordSha1CountMap, null, 4));
        let checkCount = checkResponseJson.passwordSha1CountMap[passwordSha1];
        if (checkCount) {
            globalContext.passwordMessage = {
                show: true,
                ok: false,
                error: checkCount >= 50,
                howToCheck: true,
                message: `系统检测到您设置的密码在已泄露密码中出现过 ${checkCount} 次，` + (checkCount >= 50? '强烈': '') + '不建议使用该密码'
            };
        } else {
            globalContext.passwordMessage = {
                show: true,
                ok: true,
                howToCheck: true,
                message: '系统未检测到您设置的密码出现在已知泄露密码中'
            };
        }
    }
}

$(document).ready(() => {
    $('#sign-username-form').submit(async (event) => {
        event.preventDefault();
        let response = await doSignUp();
        if (response.status !== 200) {
            let responseMessage = await response.json();
            throw `Error [${response.status}]: ${responseMessage.message}`;
        } else {
            location.href = '/';
        }
    });
});
